//+------------------------------------------------------------------+
//|                                                      EA hCCI.mq4 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#property strict

sinput int Magic=26072022;
sinput double Lot=0;

enum window {Rectangular,Triangular,FlatTop,LWMA,Power,Exponential};
input window Window=Rectangular;
enum smoothing {None,Square,Exponent};
input smoothing Smoothing=None;
input ENUM_APPLIED_PRICE iPrice=PRICE_CLOSE;
input ushort iPeriod=14;
input uchar iLevel=70;

int level=1,length=2;
double lot,weight[];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   lot=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   double lot_step=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
   lot=MathMin(lot+MathMax(0,MathRound((Lot-lot)/lot_step))*lot_step,SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX));

   length=MathMax(length,iPeriod);
   level=(uchar)MathMin(MathMax(iLevel,level),99);

   ArrayResize(weight,length);

   if(Window==Rectangular)
      ArrayInitialize(weight,1);

   if(Window==Triangular)
      for(int i=0; i<length; i++)
         weight[i]=length-MathAbs(2*i-length+1);

   if(Window==FlatTop)
     {
      int n=length-1;
      for(int i=0; i<length; i++)
         weight[i]=215578947-416631580*MathCos(2*M_PI*i/n)+277263158*MathCos(4*M_PI*i/n)-83578947*MathCos(6*M_PI*i/n)+6947368*MathCos(8*M_PI*i/n);
     }

   if(Window==LWMA)
      for(int i=0; i<length; i++)
         weight[i]=length-i;

   if(Window==Power)
      for(int i=0; i<length; i++)
         weight[i]=MathPow(length-i,2);

   if(Window==Exponential)
      for(int i=0; i<length; i++)
         weight[i]=MathPow(2,length-i-1);

   double denom=0;
   for(int i=0; i<length; i++)
      denom=denom-weight[i];

   for(int i=0; i<length; i++)
      weight[i]=weight[i]/denom;

   weight[0]=weight[0]+1;

   int bars=iPrice==PRICE_OPEN? iBars(_Symbol,PERIOD_CURRENT)-length-1:iBars(_Symbol,PERIOD_CURRENT)-length-2;
   for(int i=bars; i>=0; i--)
      CalcularionIndicator(i);

   NewBar();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(NewBar()==true)
     {
      int signal=CalcularionIndicator(0);
      if(signal==0)
         PutPosition(ORDER_TYPE_BUY);
      if(signal==1)
         PutPosition(ORDER_TYPE_SELL);
     }
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void PutPosition(ENUM_ORDER_TYPE type)
  {
//---
   int slippage=(int)MathMax(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)/2,3);
   double price=type==OP_BUY? SymbolInfoDouble(_Symbol,SYMBOL_ASK):SymbolInfoDouble(_Symbol,SYMBOL_BID);
   if(AccountFreeMarginCheck(_Symbol,type,lot)<=0)
     {
      Print("Not enough money for ",EnumToString(type)," ",lot," ",_Symbol," Error code=",GetLastError());
      return;
     }

   if(OrderSend(_Symbol,type,lot,price,slippage,0,0,NULL,Magic,0,clrNONE)<0)
      Print("OrderSend error ",GetLastError());

   for(int pos=OrdersTotal()-1; pos>=0; pos--)
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true && OrderMagicNumber()==Magic && OrderSymbol()==_Symbol)
        {
         if(type==OP_SELL && OrderType()==OP_BUY && OrderClose(OrderTicket(),OrderLots(),SymbolInfoDouble(_Symbol,SYMBOL_BID),slippage,clrNONE)==false)
            Print("Error code = ",GetLastError());
         if(type==OP_BUY && OrderType()==OP_SELL && OrderClose(OrderTicket(),OrderLots(),SymbolInfoDouble(_Symbol,SYMBOL_ASK),slippage,clrNONE)==false)
            Print("Error code = ",GetLastError());
        }
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
char CalcularionIndicator(int num_bar)
  {
//---
   static int array_dn[],size_dn,array_up[],size_up;
   static double last_cci;

   if(size_dn==0)
      ArrayResize(array_up,size_up,1000);
   if(size_up==0)
      ArrayResize(array_dn,size_dn,1000);

   int pos=iPrice==PRICE_OPEN? num_bar:num_bar+1;

   double cci=0;
   for(int j=0; j<length; j++)
      cci=cci+weight[j]*CPrice(pos+j);

   if(Smoothing==Square)
      cci=cci>=0? MathSqrt(cci):-MathSqrt(MathAbs(cci));
   if(Smoothing==Exponent)
      cci=(cci+last_cci)/2;

   if(cci>0)
     {
      ArrayResize(array_up,size_up+1);
      array_up[size_up]=(int)MathRound(cci/_Point);
      size_up++;
     }
   if(cci<0)
     {
      ArrayResize(array_dn,size_dn+1);
      array_dn[size_dn]=(int)MathRound(-cci/_Point);
      size_dn++;
     }

   if(num_bar==0)
     {
      ArraySort(array_up);
      ArraySort(array_dn);
      double lvl_up=array_up[size_up*level/100]*_Point,lvl_dn=-array_dn[size_dn*level/100]*_Point;

      if(cci>=lvl_up && last_cci>=cci)
         return(1);

      if(cci<=lvl_dn && last_cci<=cci)
         return(0);
     }

   last_cci=cci;
   return(-1);
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CPrice(int i)
  {
//---
   if(iPrice==PRICE_CLOSE)
      return(iClose(_Symbol,PERIOD_CURRENT,i));
   if(iPrice==PRICE_OPEN)
      return(iOpen(_Symbol,PERIOD_CURRENT,i));
   if(iPrice==PRICE_HIGH)
      return(iHigh(_Symbol,PERIOD_CURRENT,i));
   if(iPrice==PRICE_LOW)
      return(iLow(_Symbol,PERIOD_CURRENT,i));
   if(iPrice==PRICE_MEDIAN)
      return((iHigh(_Symbol,PERIOD_CURRENT,i)+iLow(_Symbol,PERIOD_CURRENT,i))/2);
   if(iPrice==PRICE_TYPICAL)
      return((iHigh(_Symbol,PERIOD_CURRENT,i)+iLow(_Symbol,PERIOD_CURRENT,i)+iClose(_Symbol,PERIOD_CURRENT,i))/3);
   return((iHigh(_Symbol,PERIOD_CURRENT,i)+iLow(_Symbol,PERIOD_CURRENT,i)+2*iClose(_Symbol,PERIOD_CURRENT,i))/4);
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewBar()
  {
//---
   static long last_bar;
   long cur_bar=SeriesInfoInteger(_Symbol,PERIOD_CURRENT,SERIES_LASTBAR_DATE);
   if(last_bar<cur_bar)
     {
      last_bar=cur_bar;
      return(true);
     }
   return(false);
//---
  }
//+------------------------------------------------------------------+
