//+------------------------------------------------------------------+
//|                                                         hCCI.mq5 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_level1 0
#property indicator_level2 0
#property indicator_levelcolor clrGray
#property indicator_levelstyle STYLE_DOT
#property indicator_levelwidth 1

#property indicator_applied_price PRICE_TYPICAL
#property indicator_type1  DRAW_LINE
#property indicator_label1 "hCCI"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

enum window {Rectangular,Triangular,FlatTop,LWMA,Power,Exponential};
input window Window=Rectangular;
enum smoothing {None,Square,Exponent};
input smoothing Smoothing=None;
input ushort iPeriod=14;
input uchar iLevel=70;
int level=1;
double buffer[],weight[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   if(iPeriod<2)
     {
      Alert("Minimum iPeriod = 2");
      return(INIT_FAILED);
     }
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   level=(uchar)MathMin(MathMax(iLevel,level),99);

   ArrayResize(weight,iPeriod);

   if(Window==Rectangular)
      ArrayInitialize(weight,1);

   if(Window==Triangular)
      for(int i=0; i<iPeriod; i++)
         weight[i]=iPeriod-MathAbs(2*i-iPeriod+1);

   if(Window==FlatTop)
     {
      int n=iPeriod-1;
      for(int i=0; i<iPeriod; i++)
         weight[i]=215578947-416631580*MathCos(2*M_PI*i/n)+277263158*MathCos(4*M_PI*i/n)-83578947*MathCos(6*M_PI*i/n)+6947368*MathCos(8*M_PI*i/n);
     }

   if(Window==LWMA)
      for(int i=0; i<iPeriod; i++)
         weight[i]=iPeriod-i;

   if(Window==Power)
      for(int i=0; i<iPeriod; i++)
         weight[i]=MathPow(iPeriod-i,2);

   if(Window==Exponential)
      for(int i=0; i<iPeriod; i++)
         weight[i]=MathPow(2,iPeriod-i-1);

   double denom=0;
   for(int i=0; i<iPeriod; i++)
      denom=denom-weight[i];

   for(int i=0; i<iPeriod; i++)
      weight[i]=weight[i]/denom;

   weight[0]=weight[0]+1;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
   ArraySetAsSeries(price,true);

   static int array_dn[],size_dn,array_up[],size_up;
   static double last_cci;

   int bars=rates_total-prev_calculated;

   if(prev_calculated==0)
     {
      bars=rates_total-iPeriod-1;
      ArrayResize(array_up,size_up,rates_total);
      ArrayResize(array_dn,size_dn,rates_total);
     }

   for(int i=bars; i>=0; i--)
     {
      double cci=0;
      for(int j=0; j<iPeriod; j++)
         cci=cci+weight[j]*price[i+j];


      if(Smoothing==Square)
         cci=cci>=0? MathSqrt(cci):-MathSqrt(MathAbs(cci));
      if(Smoothing==Exponent)
        {
         cci=(cci+last_cci)/2;
         if(i>0)
            last_cci=cci;
        }

      if(i>0)
        {
         if(cci>0)
           {
            ArrayResize(array_up,size_up+1);
            array_up[size_up]=(int)MathRound(cci/_Point);
            size_up++;
           }
         if(cci<0)
           {
            ArrayResize(array_dn,size_dn+1);
            array_dn[size_dn]=(int)MathRound(-cci/_Point);
            size_dn++;
           }

         if(i==1)
           {
            ArraySort(array_up);
            IndicatorSetDouble(INDICATOR_LEVELVALUE,0,array_up[size_up*level/100]*_Point);
            ArraySort(array_dn);
            IndicatorSetDouble(INDICATOR_LEVELVALUE,1,-array_dn[size_dn*level/100]*_Point);
           }
        }

      buffer[i]=cci;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
