//+------------------------------------------------------------------+
//|                                                         lCCI.mq4 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "lCCI"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

enum window {Rectangular,Triangular,FlatTop,LWMA,Power,Exponential};
input window Window=Rectangular;
enum direct {Straight,Back};
input direct Direct=Straight;
input ENUM_APPLIED_PRICE iPrice=PRICE_TYPICAL;
input ushort iPeriod=14;
double buffer[],weight[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   if(iPeriod<2)
     {
      Alert("Minimum iPeriod = 2");
      return(INIT_FAILED);
     }
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   ArrayResize(weight,iPeriod);

   if(Window==Rectangular)
      ArrayInitialize(weight,1);

   if(Window==Triangular)
      for(int i=0; i<iPeriod; i++)
         weight[i]=iPeriod-MathAbs(2*i-iPeriod+1);

   if(Window==FlatTop)
     {
      int n=iPeriod-1;
      for(int i=0; i<iPeriod; i++)
         weight[i]=215578947-416631580*MathCos(2*M_PI*i/n)+277263158*MathCos(4*M_PI*i/n)-83578947*MathCos(6*M_PI*i/n)+6947368*MathCos(8*M_PI*i/n);
     }

   if(Window==LWMA)
      for(int i=0; i<iPeriod; i++)
         weight[i]=iPeriod-i;

   if(Window==Power)
      for(int i=0; i<iPeriod; i++)
         weight[i]=MathPow(iPeriod-i,2);

   if(Window==Exponential)
      for(int i=0; i<iPeriod; i++)
         weight[i]=MathPow(2,iPeriod-i-1);

   double denom=0;

   for(int i=0; i<iPeriod; i++)
      denom=Direct==Straight? denom-weight[i]:denom+weight[i];

   for(int i=0; i<iPeriod; i++)
      weight[i]=Direct==Straight? weight[i]/denom:2*weight[i]/denom;

   weight[0]=Direct==Straight? weight[0]+2:weight[0]-1;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(close,true);

   int bars=prev_calculated>0? rates_total-prev_calculated:rates_total-iPeriod-1;

   for(int i=bars; i>=0; i--)
     {
      double cci=0;
      for(int j=0; j<iPeriod; j++)
        {
         int p=i+j;
         cci=cci+weight[j]*price(open[p],high[p],low[p],close[p]);
        }

      buffer[i]=cci;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double price(double o,double h,double l,double c)
  {
//---
   if(iPrice==PRICE_CLOSE)
      return(c);
   if(iPrice==PRICE_OPEN)
      return(o);
   if(iPrice==PRICE_HIGH)
      return(h);
   if(iPrice==PRICE_LOW)
      return(l);
   if(iPrice==PRICE_MEDIAN)
      return((h+l)/2);
   if(iPrice==PRICE_TYPICAL)
      return(h+l+c)/3;
   return(h+l+2*c)/4;
//---
  }
//+------------------------------------------------------------------+
