//+------------------------------------------------------------------+
//|                                                         pCCI.mq4 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_level1 0
#property indicator_level2 0
#property indicator_levelcolor clrGray
#property indicator_levelstyle STYLE_DOT
#property indicator_levelwidth 1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "pCCI"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

enum type_ind {Classical,Square,Modern};
input type_ind TypeInd=Classical;
input ENUM_APPLIED_PRICE iPrice=PRICE_TYPICAL;
input ushort iPeriod=14;
input uchar iLevel=70;

int indx10,indx11,indx20,indx21,level=1;
double buffer[],halfsums[],diff[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   if(iPeriod<2)
     {
      Alert("Minimum iPeriod = 2");
      return(INIT_FAILED);
     }
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   SetIndexEmptyValue(0,EMPTY_VALUE);

   if(TypeInd==Modern)
     {
      int size=iPeriod*(iPeriod-1)/2;
      ArrayResize(halfsums,size);
      indx10=size/2;
      indx11=MathMod(size,2)==0? indx10-1:indx10;

      ArrayResize(diff,iPeriod);
      indx20=iPeriod/2;
      indx21=MathMod(iPeriod,2)==0? indx20-1:indx20;
     }

   level=(uchar)MathMin(MathMax(iLevel,level),99);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(close,true);

   static int array_dn[],size_dn,array_up[],size_up;
   int bars=rates_total-prev_calculated;

   if(prev_calculated==0)
     {
      bars=rates_total-iPeriod-1;
      ArrayResize(array_up,size_up,rates_total);
      ArrayResize(array_dn,size_dn,rates_total);
     }

   for(int i=bars; i>=0; i--)
     {
      double cci=0,cur_price=price(open[i],high[i],low[i],close[i]);
      if(TypeInd==Classical)
        {
         double mean=0,stdev=0;
         for(int j=0; j<iPeriod; j++)
           {
            int p=i+j;
            mean=mean+price(open[p],high[p],low[p],close[p]);
           }
         mean=mean/iPeriod;
         for(int j=0; j<iPeriod; j++)
           {
            int p=i+j;
            stdev=stdev+MathAbs(price(open[p],high[p],low[p],close[p])-mean);
           }

         cci=cur_price>=mean? MathSqrt((cur_price-mean)*stdev/iPeriod):-MathSqrt((mean-cur_price)*stdev/iPeriod);
        }

      if(TypeInd==Square)
        {
         double sumS=0,sumQ=0;
         for(int j=0; j<iPeriod; j++)
           {
            int p=i+j;
            double pr=price(open[p],high[p],low[p],close[p]);
            sumS=sumS+pr;
            sumQ=sumQ+pr*pr;
           }
         double mean=sumS/iPeriod,stdev=MathSqrt(iPeriod*sumQ-sumS*sumS)/iPeriod;
         cci=cur_price>=mean? MathSqrt((cur_price-mean)*stdev):-MathSqrt((mean-cur_price)*stdev);
        }

      if(TypeInd==Modern)
        {
         int cnt=0;
         for(int j=iPeriod-2; j>=0; j--)
           {
            int p=i+j;
            double pr=price(open[p],high[p],low[p],close[p]);
            for(int k=iPeriod-1; k>j; k--)
              {
               p=i+k;
               halfsums[cnt]=pr+price(open[p],high[p],low[p],close[p]);
               cnt++;
              }
           }
         ArraySort(halfsums);
         double mean=(halfsums[indx10]+halfsums[indx11])/4;
         for(int j=0; j<iPeriod; j++)
           {
            int p=i+j;
            diff[j]=MathAbs(price(open[p],high[p],low[p],close[p])-mean);
           }
         ArraySort(diff);
         double stdev=(diff[indx20]+diff[indx21])/2;
         cci=cur_price>=mean? MathSqrt((cur_price-mean)*stdev):-MathSqrt((mean-cur_price)*stdev);
        }

      if(i>0)
        {
         if(cci>0)
           {
            ArrayResize(array_up,size_up+1);
            array_up[size_up]=(int)MathRound(cci/_Point);
            size_up++;
           }
         if(cci<0)
           {
            ArrayResize(array_dn,size_dn+1);
            array_dn[size_dn]=(int)MathRound(-cci/_Point);
            size_dn++;
           }

         if(i==1)
           {
            ArraySort(array_up);
            IndicatorSetDouble(INDICATOR_LEVELVALUE,0,array_up[size_up*level/100]*_Point);
            ArraySort(array_dn);
            IndicatorSetDouble(INDICATOR_LEVELVALUE,1,-array_dn[size_dn*level/100]*_Point);
           }
        }

      buffer[i]=cci;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double price(double o,double h,double l,double c)
  {
//---
   if(iPrice==PRICE_CLOSE)
      return(c);
   if(iPrice==PRICE_OPEN)
      return(o);
   if(iPrice==PRICE_HIGH)
      return(h);
   if(iPrice==PRICE_LOW)
      return(l);
   if(iPrice==PRICE_MEDIAN)
      return((h+l)/2);
   if(iPrice==PRICE_TYPICAL)
      return(h+l+c)/3;
   return(h+l+2*c)/4;
//---
  }
//+------------------------------------------------------------------+
